const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PositionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const positions = await db.positions.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        job_family: data.job_family || null,
        level: data.level || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await positions.setManager(data.manager || null, {
      transaction,
    });

    await positions.setOrganizations(data.organizations || null, {
      transaction,
    });

    return positions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const positionsData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      job_family: item.job_family || null,
      level: item.level || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const positions = await db.positions.bulkCreate(positionsData, {
      transaction,
    });

    // For each item created, replace relation files

    return positions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const positions = await db.positions.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.job_family !== undefined)
      updatePayload.job_family = data.job_family;

    if (data.level !== undefined) updatePayload.level = data.level;

    updatePayload.updatedById = currentUser.id;

    await positions.update(updatePayload, { transaction });

    if (data.manager !== undefined) {
      await positions.setManager(
        data.manager,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await positions.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return positions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const positions = await db.positions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of positions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of positions) {
        await record.destroy({ transaction });
      }
    });

    return positions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const positions = await db.positions.findByPk(id, options);

    await positions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await positions.destroy({
      transaction,
    });

    return positions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const positions = await db.positions.findOne({ where }, { transaction });

    if (!positions) {
      return positions;
    }

    const output = positions.get({ plain: true });

    output.manager = await positions.getManager({
      transaction,
    });

    output.organizations = await positions.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'manager',

        where: filter.manager
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.manager
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.manager
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('positions', 'title', filter.title),
        };
      }

      if (filter.job_family) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('positions', 'job_family', filter.job_family),
        };
      }

      if (filter.level) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('positions', 'level', filter.level),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.positions.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('positions', 'title', query),
        ],
      };
    }

    const records = await db.positions.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
